#ifndef _SHARED_H_
#define _SHARED_H_

extern D3DXMATRIX mSHIdentity;
extern D3DXMATRIX mSHWorldView;
extern D3DXMATRIX mSHWorldViewProj;
extern D3DXMATRIX mSHViewProj;
extern D3DXMATRIX mSHViewProjBias;
extern D3DXMATRIX mSHProjBias;
extern D3DXMATRIX mSHInvView;
extern D3DXMATRIX mSHInvProj;
extern D3DXMATRIX mSHFrustum;

extern LPD3DXEFFECT	pSharedFX;

extern float fTime;
extern float fTimePrev;
extern float fTimeDelta;
extern float fPattern;

#define FRAND ((float)rand()/32768.0f)

bool SHIsPlaying();
void SHInit();
void SHStart();
void SHTerminate();
const MiniEngine::RenderTarget& SHBlur(float fBlurSize=1.0f,
							 int iNumPasses=1,
							 const D3DXVECTOR4& vBlurColour=D3DXVECTOR4(1.0f, 1.0f, 1.0f, 1.0f),
							 float fBlurThreshold=0.0f);

void SHResetMatrices();
void SHSetWorldViewProjBias(const D3DXMATRIX* pWorld, const D3DXMATRIX* pView, const D3DXMATRIX *pProj, const D3DXMATRIX *pBias);
void SHNewFrame();
#endif
